# -*- coding: UTF-8 -*-
###########################################################################
# Eole NG - 2007  
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr 
###########################################################################
"""
Fichier de configuration de l'application Zephir
"""
from os.path import join, dirname, abspath
from creole.parsedico import parse_dico
import locale

conf = parse_dico()

charset = "UTF8"

ADRESSE_LDAP = conf["serveur_ldap"]
ADRESSE_ZEPHIR = conf["adresse_ip_eth0"]
BASE_LDAP = conf["base_ldap"]
PORT_HTTP = "8090"
PORT_ZEPHIR = "7080"
PORT_WEB = 8070
# répertoire de base appli 
ROOT_DIR = "/usr/share/zephir/"
PORT_AGENT = "8090"
AGENT_DIR = "agents"
CLIENT_UPDATE_HOST = "eole.orion.education.fr"
CLIENT_UPDATE_URL = "/Extras/RPMS"
CLIENT_NG_URL = "/Extras/RPMS/eoleng"

MAIL_ADRESSE = conf["serveur_smtp"]
MAIL_PORT = conf["port_smtp"]
MAIL_ACCOUNT = conf["compte_smtp"]

# répertoire de base des donnees backend
PATH_ZEPHIR = "/var/lib/zephir/"
PATH_TEMP = join("/tmp")
ADRESSE_SAUVEGARDE = join(PATH_ZEPHIR, 'user_prefs')

# manager prelude par défaut
PRELUDE_PORT = 4691
# liste des modules eole
liste_modules = ['amon-1.5','sphynx-1.1','scribe-1.0','horus-1.0','amon-2.0','sphynx-2.0','scribe-2.0','horus-2.0','zephir-2.0','preludemanager-2.0','zephirlogs-2.0']
# liste des modules utilisant creole1
OLD_MODULES = ['amon-1.5','sphynx-1.0','sphynx-1.0','sphynx-1.1','scribe-1.0','horus-1.0']
# liste des verrous existants et de leurs dépendances
verrous = {'uucp':['Execution des tâches Zephir'],
           'sauvegarde':['Maj-Auto','Maj-Cd'],
           'maj':[],
           'configure':[],
           'reconfigure':[]}

# libellés à affecter aux différents types de restrictions de ressources, table et champs correspondant (pour validation)
type_res_label =  {'rne':('numéro RNE', 'etablissements', 'rne'),
                   'groupe':('numéro de groupe', 'groupes_serveurs', 'id'),
                   'id_s':('numéro de serveur', 'serveurs', 'id'),
                   'id_var':('numéro de variante', 'variantes', 'id'),
                   'id_mod':('numéro de module', 'modules', 'id'),
                  }

# correspondance des caractères pour les xml des agents eole1
xml_table={'\\xc9':'\\xc3\\xa9',
           '\\xe9':'\\xc3\\xa9',
           '\\xc8':'\\xc3\\xa8',
           '\\xe8':'\\xc3\\xa8',
           '\\xf4':'\\xc3\\xb4',
           '\\xe0':'\\xc3\\xa0',
           }

# temps entre chaque vérification des timeout (secondes)
SCAN_DELAY = 300
