# -*- coding: UTF-8 -*-
###########################################################################
# Eole NG - 2007  
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr 
#  
# ldap_user.py
#  
#  Utilitaire de gestion d'utilisateurs LDAP pour zephir
#       
###########################################################################

import ldap, getpass, sys

def add_user(login,passwd,pass_ldap):
    l = ldap.open('127.0.0.1')
    try:
        l.simple_bind_s('cn=admin,o=gouv,c=fr',pass_ldap)
    except:
        sys.exit("\nerreur d'authentification\n")

    # si la racine n'existe pas, on la crée
    try:
        result = l.search_s("o=gouv, c=fr", ldap.SCOPE_SUBTREE,"(&(objectClass=organization)(o=gouv))")
    except ldap.NO_SUCH_OBJECT:
        result = []
    if result == []:
        l.add_s('o=gouv,c=fr', [('objectClass','organization'),('o','gouv'),('description','Gouvernemental')])

    # on regarde si il existe
    result = l.search_s("o=gouv, c=fr", ldap.SCOPE_SUBTREE,"(&(objectClass=OpenLDAPperson)(uid="+login+"))")
    if result == []:
        # si non on le crée
        try:
            l.add_s('uid='+login+',o=gouv,c=fr', [('objectClass','OpenLDAPperson'),('uid',login),('cn',login),('sn',login),('UserPassword',passwd)])
        except:
            print("\nerreur d'authentification\n")
    else:
        # si il existe déjà on modifie son mot de passe
        try:
            l.modify_s('uid='+login+',o=gouv,c=fr', [(ldap.MOD_REPLACE,'UserPassword',passwd)])
        except:
            print("\nerreur d'authentification\n")

    l.unbind()

def del_user(login,pass_ldap):
    l = ldap.open('127.0.0.1')
    try:
        l.simple_bind_s('cn=admin,o=gouv,c=fr',pass_ldap)
    except:
        sys.exit("\nerreur d'authentification\n")

    # si la racine n'existe pas, on la crée
    result = l.search_s("o=gouv, c=fr", ldap.SCOPE_SUBTREE,"(&(objectClass=OpenLDAPperson)(uid=%s))" % login)
    if len(result) != 1:
        print "\nerreur, cet utilisateur n'existe pas\n"
        return 0
    else:
        # si il existe, on le supprime 
        try:
            l.delete_s(result[0][0])
        except:
            return 0
        else:
            return 1

    l.unbind()

def list_user(pass_ldap):
    l = ldap.open('127.0.0.1')
    try:
        l.simple_bind_s('cn=admin,o=gouv,c=fr',pass_ldap)
    except:
        sys.exit("\nerreur d'authentification\n")

    # si la racine n'existe pas, on la crée
    result = l.search_s("o=gouv, c=fr", ldap.SCOPE_SUBTREE,"(objectClass=OpenLDAPperson)")
    l.unbind()
    if result == []:
        print "\n Aucun utilisateur trouvé dans l'annuaire local\n"
    else:
        # on affiche tous les utilisateurs
        print "\n liste des utilisateurs zephir :\n"
        for user in result:
            print "- " + str(user[1]['cn'][0])
        print "\n"
