#!/bin/sh
###########################################################################
# Eole NG - 2007  
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr 
#  
# backup_zephir1.sh
#  
# utilitaire de sauvegarde d'un serveur zephir1 pour import sur un 
# serveur zephir NG
#       
###########################################################################

# color ASCII codes
#
DEFAULT="\e[0m"
BOLD="\e[1m"
BLACK="\e[30m"
RED="\e[31m"
GREEN="\e[32m"
YELLOW="\e[33m"
BLUE="\e[34m"
VIOLET="\e[35m"
CYAN="\e[36m"
WHITE="\e[37m"


Lock="sauvegarde"
Excl="maj"

RepEole=${RepEole="/usr/share/eole"}
# Appel Bibliothque Eole
[ -x $RepEole/FonctionsEole ] || {
        echo -e "Pas de bibliotheque Eole !"
	exit 1
	}
. $RepEole/FonctionsEole 
ParseDico

day=backup_`date +%d-%m-%Y`
backup_dir=/var/lib/zephir_backups
tmp_backup=$backup_dir/$day
pg_dir=/var/lib/pgsql
pg_perms=$pg_dir/data/pg_hba.conf

if [ ! -d $backup_dir ]
then
	mkdir $backup_dir
fi
rm -rf $tmp_backup
mkdir $tmp_backup

# postgres : se mettre en mode sans mot de passe
mv -f $pg_perms $pg_perms.savezephir
echo -e -e "local\tall\tall\ttrust" > $pg_perms
chown postgres.postgres $pg_perms
chmod 600 $pg_perms
service postgresql reload

# sauvegarde des donnes de la base postgresql
echo -e
echo -e "${CYAN}Sauvegarde en cours, patientez ...${DEFAULT}"

echo -e " - base postgresql"
su - postgres -c "pg_dumpall > /tmp/backup_db.sql"
mv /tmp/backup_db.sql $tmp_backup/backup_db.sql

# postgres : se remettre en mode mot de passe
rm -f $pg_perms
mv -f $pg_perms.savezephir $pg_perms
chown postgres.postgres $pg_perms
chmod 600 $pg_perms
service postgresql reload

# sauvegarde des rpertoires et fichiers importants

pushd /var/lib > /dev/null 2>&1

echo -e " - base ldap"
# sauvegarde de la base ldap
slapcat -l $tmp_backup/ldap.ldif
echo -e " - configuration des serveurs"
# /var/lib/zephir
tar -cpf $tmp_backup/var_lib_zephir.tar zephir
# /etc/uucp/
cd /etc
tar -cpf $tmp_backup/etc_uucp.tar uucp
echo -e " - cls de connexion"
# /var/spool/uucp/
cd /var/spool
tar -cpf $tmp_backup/var_spool_uucp.tar uucp

echo -e " - configuration eole"
cd /etc/eole
tar -cpf $tmp_backup/etc_eole.tar config.eol dicos patch
 
# cration du fichier de sauvegarde compress
echo -e "${CYAN}Compression de l'archive...${DEFAULT}"
cd $backup_dir
tar -czf $day.tar.gz $day
echo -e
echo -e "${GREEN}Archive cre : $backup_dir/$day.tar.gz${DEFAULT}"
echo -e

# suppression du rpertoire temporaire
rm -rf $tmp_backup
# retour au rpertoire d'origine
popd >/dev/null 2>&1
