#!/usr/bin/env python
# -*- coding: UTF-8 -*-
"""Insert coding line into all python files
USAGE :
  insert_coding [-b] directory coding
  -b : ne pas faire de backups
"""
 
__revision__ = '$Id: insert_coding.py,v 1.3 2004/06/10 12:15:33 bboiget Exp $'
 
import os, sys, shutil
 
def make_backup(filepath):
    """Make a backup of file located at 'filepath'
    """
    backup_file = filepath + '.bak'
    # print "%s --> %s" % (filepath, backup_file)
    shutil.copy(filepath, backup_file)
 
 
def insert_coding(filepath, backup_mode, coding = 'UTF-8'):
    """Insert the coding line in file located at 'filepath'
    """
    coding_line = '# -*- coding: %s -*-' % coding
    # 1 - retrieve original content
    f = file(filepath,'r')
    content = f.read()
    f.close()
    firstline=content.split("\n")[0]
    if filepath.endswith('.py') or ( firstline.count('#!') >= 1 and firstline.count('python') >=1 ):
        if content.strip() != "":
            if content.find("-*- coding:") == -1:
                lignes = content.split("\n")
                if firstline.startswith('#!'):
                    print "\tinsertion dans le fichier python %s " % os.path.basename(filepath)
                    # on insère en deuxième ligne
                    new_content = [lignes[0]]
                    new_content.append(coding_line)
                    new_content.extend(lignes[1:])
                else:
                    print "\tinsertion dans le script %s " % os.path.basename(filepath)
                    # on insère en première ligne
                    new_content =  [coding_line]
                    new_content.extend(lignes)
                    
                # 2 - add coding line
                if len(new_content) > 1:
                    if backup_mode == 1:
                        make_backup(filepath)
                    f = file(filepath, 'w')
                    f.write("\n".join(new_content))
                    f.close()
 
 
def process_dir(backup_mode, directory, coding = 'UTF-8', recursive = True):
    """Insert coding in all python files
    """
    directory = os.path.realpath(directory)
    for filename in os.listdir(directory):
        if not (filename.startswith('.') or filename == 'CVS'):
            filename = os.path.join(directory, filename)
            if os.path.isdir(filename) and recursive:
                process_dir(backup_mode, filename, coding, recursive)
            elif not filename.endswith('.bak') or filename.endswith('~'):
                insert_coding(filename, backup_mode, coding)
 
def run(backup_mode, directory, coding = 'UTF-8'):
    """ main routine """
    process_dir(backup_mode, directory, coding, recursive = True)
 

if __name__ == '__main__':
    if len(sys.argv) < 2:
        sys.exit(__doc__)
    # on regarde si il faut faire des backups
    backup_mode = 1
    if '-b' in sys.argv[1:]:
        print "\n***backup non activé***"
        backup_mode = 0
        sys.argv.remove('-b')
    else:
        print "\n***backup des fichiers modifiés***"
    # on traite les répertoires demandés
    for directory in sys.argv[1:]:
        print " - Traitement récursif du répertoire %s\n" % directory
        try:
            run(backup_mode, directory)
        except TypeError:
            print __doc__
    print "\n"
