#!/usr/bin/env python
# -*- coding: UTF-8 -*-
###########################################################################
# Eole NG - 2007  
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr 
#  
# migrate_base.py
#  
# script de mise a jour de la base zephir après migration d'une
# sauvegarde zephir 1
#       
###########################################################################
import xmlrpclib, getpass, os, sys, glob, time, socket
from zephir.config import *
from creole import parsedico
from creole.cfgparser import EoleDict
import dico

# récupération du login admin
dictionnaire = parsedico.parse_dico()
admin_zephir = dictionnaire['admin_zephir']
try:
    passwd = sys.argv[1]
except:
    sys.exit("! mot de passe %s requis, abandon de la procédure !" % admin_zephir)

z = xmlrpclib.ServerProxy('https://%s:%s@%s:%s' % (admin_zephir, passwd, ADRESSE_ZEPHIR, PORT_ZEPHIR))
# création des modules
id_mods = {}
# on attend 3 secondes si le service n'est pas démarré (3 tentatives max)
service_error = 0
while service_error < 3:
    try:
        mods = z.modules.get_module()[1]
        service_error = 4
    except socket.error:
        time.sleep(3)
        service_error += 1
if service_error == 3:
    sys.exit("! Erreur, le service zephir n'a pas redémarré correctement !")

for mod in mods:
    id_mods[mod['libelle']]=mod['id']
libelles = []
for module in liste_modules:
    if module not in OLD_MODULES:
        version = 2
        data = z.modules.add_module(module, version)
        res, id_module = data
        if res == 0:
            print "\nerreur de création du module %s : %s\n" % (module,id_module)
        else:
            # Eole 2
            dicos = {}
            for dico_eol in glob.glob("/usr/share/zephir/dictionnaires/%s/*.xml" % module):
                # lecture des dictionnaires et de leur nom
                data = open(dico_eol).read()
                dicos[os.path.basename(dico_eol)] = xmlrpclib.base64.encodestring(data)
            res, info = z.uucp.install_module(int(id_module),dicos)
            if res == 0:
                print "erreur d'envoi du dictionnaire pour le module %s" % module
    else:
        # modules Eole1 : on force la version du module à 1
        if id_mods.has_key(module):
            res, msg = z.modules.edit_module(int(id_mods[module]),{'version':1})
            if res != 1:
                print "erreur de mise à jour de la version du module %s (%s)" % (module,msg)

# gestion du dictionnaire
print " - conversion de la configuration du serveur au nouveau format"
try:
    new_dict = EoleDict()
    new_dict.read_dir('/etc/eole/dicos')
    new_dict.load_values('/etc/eole/config.eol')
    old_dict = dico.DicoEole('./config.eol')
    # copie des anciennes valeurs
    for var in new_dict.variables.keys():
        use_local = False
        obligatoire = 'obligatoire' in [check[0] for check in new_dict.variables[var].checks]
        if not old_dict.liste_vars.has_key(var):
            use_local = True
        elif old_dict.get_value(var) == '' and obligatoire:
            use_local = True
        if use_local:
            # cas des variables obligatoires non renseignées si une valeur est disponible
            new_dict.set_value(var, new_dict.get_value(var))
            print "   * %s : utilisation de la valeur actuelle (%s)**" % (var, ", ".join(new_dict.get_value(var)))
        else:
            new_dict.set_value(var, old_dict.get_value(var))
    # # on prend la valeur calculée par défaut pour l'adresse de broadcast
    # default_broadcast = new_dict.get_value('adresse_broadcast_eth0')
    # new_dict.set_value('adresse_broadcast_eth0',default_broadcast)

    # sauvegarde du fichier de configuration
    new_dict.save_values('/root/migration.eol')
    print "\n   La configuration du serveur a été convertie"
    print "   lancez la commande 'instance /root/migration.eol'\n"
    print "   si vous voulez reprendre la configuration d'origine\n"
except Exception, e:
    os.system('cp config.eol /tmp/old-conf.eol')
    print "\n   Erreur de conversion de la configuration du serveur (%s)" % str(e)
    print "   utilisez gen_config et instance pour configurer le serveur"
    print "   cf. %s pour les valeurs d'origine\n" % os.path.abspath('/tmp/old-conf.eol')
